#!/usr/local/bin/perl
##-----------------------------------------------------------------##
##                                                                 ##
##                                                                 ##
##  Copyright Mr Lyle R Hopkins 1999. All rights reserved. No part##
## of this or any of the attached documents shall be               ##
## reproduced/stored in any way whatsoever without written         ##
## permission from the Copyright holder.                           ##
##   The Copyright holder holds no responsibility for errors or    ##
## omissions. No liability is assumed in any way for damages       ##
## resulting from the use of this document/program.                ##
##                                                                 ##
## Have a nice day.                                                ##
##                                                                 ##
##                                                                 ##
##-----------------------------------------------------------------##

## By Lyle Hopkins ##

print "Content-type: text/html\n\n";

##################################################
######################## Define variables
##################################################

$programurl = "http://ukzone.hypermart.net/test-bin/asrs";
$density = 0.02;
$myurl = "http://ukzone.hypermart.net/index.html";
$searchresultspage = "http://ukzone.hypermart.net/test-bin/asrs/results.html";
$maxtodisplay = 10;

## Display colour options
$rankfont = "Arial,Helvetica";
$rankcolour = "#000099";
$ranksize = "+1";
$sitenfont = "Arial,Helvetica";
$sitencolour = "#3333FF";
$sitensize = "+1";
$sitedfont = "Arial,Helvetica";
$sitedcolour = "#000099";
$sitedsize = "+1";
$siteufont = "Arial,Helvetica";
$siteucolour = "#000099";
$siteusize = "+1";
$tablebg = "#CCFFFF";


##################################################
######################## Other variables
##################################################

use LWP::Simple;

@values = split(/\&/,$ENV{'QUERY_STRING'});
foreach $i (@values) {
($varname, $mydata) = split(/=/,$i); ## 50
$mydata =~ tr/+/ /;
$mydata =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
$WHATWANT{$varname} = $mydata;
}

$SCORELIST = "";


##################################################
######################## See what to do
##################################################

if ($WHATWANT{'want'} eq "search") {
      &sortsearch();
   }
if ($WHATWANT{'want'} eq "addsite") {
      &addsite();
   }
if ($WHATWANT{'want'} eq "remove") {
      &removelisting();
   }
if ($WHATWANT{'want'} eq "admin") {
      &admin();
   }
if ($WHATWANT{'want'} eq "enteradmin") {
	## Get user input
   read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
   @pairs = split(/&/, $buffer);
   foreach $pair (@pairs) {
   ($name, $value) = split(/=/, $pair);
   $value =~ tr/+/ /;
   $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
   $FORM{$name} = $value;
   }
	## Get file Username and password
   open(INF,"adminpass.txt"); ## Open read file
   $userpass = <INF>; ## Put into an array
   close(INF); ## Close file
   chomp($userpass);
   ($username, $password) = split(/:/, $userpass);
   $enterpasscrypt = crypt($FORM{'password'}, substr($password, 0, 2));
	## If they match
   if ($FORM{'username'} eq $username && $enterpasscrypt eq $password){
      &enteradmin();
   } ## End if
   }


##################################################
######################## Actions to take
##################################################

##################################################
######################## Sort search input
##################################################

sub sortsearch {

@SEARCHINPUTLIST = split(/ /, $WHATWANT{'terms'});

$numberofterms = 0;
foreach $term (@SEARCHINPUTLIST) {
$numberofterms++;
}
## $WHATWANT{'terms'} =~ / /gis;

&showlist();

} ## End sub


##################################################
######################## Display toplist
##################################################

sub showlist {

&resultsgenerator();

## Display top
print "$pagetop";

print "<table CELLSPACING=3 CELLPADDING=3 BORDER=1 WIDTH=\"100%\" BGCOLOR=\"$tablebg\">";

$linenum = 1;
open(INF,"searchindex.asrs"); ## Open read file
@userdata = <INF>; ## Put into an array
close(INF); ## Close file
foreach $line (@userdata) {
chomp($line);
$sitescore = 0;
($word1, $score1, $word2, $score2, $word3, $score3, $word4, $score4, $word5, $score5, $word6, $score6, $sitename, $description, $url) = split(//, $line);
foreach $key (@SEARCHINPUTLIST) {
  if ($word1 eq "$key") {
  $sitescore = $sitescore + $score1;
  }
  if ($word2 eq "$key") {
  $sitescore = $sitescore + $score2;
  }
  if ($word3 eq "$key") {
  $sitescore = $sitescore + $score3;
  }
  if ($word4 eq "$key") {
  $sitescore = $sitescore + $score4;
  }
  if ($word5 eq "$key") {
  $sitescore = $sitescore + $score5;
  }
  if ($word6 eq "$key") {
  $sitescore = $sitescore + $score6;
  }
}
if ($sitescore ne 0) {
$sitescore = $sitescore / $numberofterms;
$SCORELIST .= "$sitescore";
$SITESEARCHLIST{$linenum} = "$sitename$description$url$sitescore";
} ## End if
$linenum++;
}

@SCORELIST = split(//, $SCORELIST);

@SCORELIST = sort { $a <=> $b }@SCORELIST;
@SCORELIST = reverse(@SCORELIST);


$ranknumber = 1;
foreach $hitnumber (@SCORELIST) {

  foreach $key (keys(%SITESEARCHLIST)) {
  ($sitename, $description, $url, $score) = split(//, $SITESEARCHLIST{$key});
    if ($score == $hitnumber) {
    ## display site
	if ($sitename ne "") {
	&style1();
	$ranknumber++;
	} ## End if
    $SITESEARCHLIST{$key} = "";
    }
  } ## End loop
} ## End loop

## Display bottom
print "</table>";
print "$pagebottom";

print <<EndHTML;
<center><table BORDER WIDTH="150" >
<tr>
<td>
<center><font face="Comic Sans MS"><font color="#000099"><font size=-2>This
script &amp; more available from</font></font></font>
<br><font face="Comic Sans MS"><font color="#FF0000"><font size=-2>-Lyles
Script archive-</font></font></font>
<br><font face="Comic Sans MS"><font color="#000099"><font size=-2><a href="http://ukzone.hypermart.net/scripts">Click
here</a></font></font></font></center>
</td>
</tr>
</table></center>
EndHTML
;

} ## End sub


##################################################
######################## Add site
##################################################

sub addsite {

read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
@pairs = split(/&/, $buffer);
foreach $pair (@pairs) {
($name, $value) = split(/=/, $pair);
$value =~ tr/+/ /;
$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
$FORM{$name} = $value;
}


&scoreit();

## Check for duplicate
$linenum = 1;
$updateinfofile = 0;
open(INF,"searchindex.asrs"); ## Open read file
@userdata = <INF>; ## Put into an array
close(INF); ## Close file
foreach $line (@userdata) {
chomp($line);
($word1, $score1, $word2, $score2, $word3, $score3, $word4, $score4, $word5, $score5, $word6, $score6, $sitename, $description, $url) = split(//, $line);
$TEMPINFO{$linenum} = $line;
if ($url eq $FORM{'url'}) {
print "Site is already in data-base, data will be updated";
$updateinfofile = 1;
$TEMPINFO{$linenum} = "$FORM{'word1'}$scoring1$FORM{'word2'}$scoring2$FORM{'word3'}$scoring3$FORM{'word4'}$scoring4$FORM{'word5'}$scoring5$FORM{'word6'}$scoring6$FORM{'sitename'}$FORM{'description'}$FORM{'url'}\n";
} ## End if
$linenum++;
} ## End loop

if ($updateinfofile) {

open(OUTF,">searchindex.asrs"); ##  Banner file for appending
foreach $key (keys(%TEMPINFO)) {
print OUTF
"$TEMPINFO{$key}\n"; ## Write user fields
}
close(OUTF); ## Close file
exit;

} ## End if


open(OUTF,">>searchindex.asrs");
print OUTF
"$FORM{'word1'}$scoring1$FORM{'word2'}$scoring2$FORM{'word3'}$scoring3$FORM{'word4'}$scoring4$FORM{'word5'}$scoring5$FORM{'word6'}$scoring6$FORM{'sitename'}$FORM{'description'}$FORM{'url'}\n"; ## Write user fields
close(OUTF); ## Close file

print "Site added";

} ## End sub


##################################################
######################## Score page
##################################################

sub scoreit {

$content = get($FORM{'url'}); ## data holds user input

## Word variables
$word1den = 0;
while ($content =~ /($FORM{'word1'})/gis) {
$word1den++;
} ## End while

$word2den = 0;
while ($content =~ /($FORM{'word2'})/gis) {
$word2den++;
} ## End while

$word3den = 0;
while ($content =~ /($FORM{'word3'})/gis) {
$word3den++;
} ## End while

$word4den = 0;
while ($content =~ /($FORM{'word4'})/gis) {
$word4den++;
} ## End while

$word5den = 0;
while ($content =~ /($FORM{'word5'})/gis) {
$word5den++;
} ## End while

$word6den = 0;
while ($content =~ /($FORM{'word6'})/gis) {
$word6den++;
} ## End while

## Get devider
while ($content =~ / /gis) {
$spacecount++;
} ## End while

## Scoring
$scoring1 = ($word1den / $spacecount) / $density;
if ($scoring1 > 1) {
$scoring1 = ($word1den / $spacecount) * $density;
}
$scoring2 = ($word2den / $spacecount) / $density;
if ($scoring2 > 1) {
$scoring2 = ($word2den / $spacecount) * $density;
}
$scoring3 = ($word3den / $spacecount) / $density;
if ($scoring3 > 1) {
$scoring3 = ($word3den / $spacecount) * $density;
}
$scoring4 = ($word4den / $spacecount) / $density;
if ($scoring4 > 1) {
$scoring4 = ($word4den / $spacecount) * $density;
}
$scoring5 = ($word5den / $spacecount) / $density;
if ($scoring5 > 1) {
$scoring5 = ($word5den / $spacecount) * $density;
}
$scoring6 = ($word6den / $spacecount) / $density;
if ($scoring6 > 1) {
$scoring6 = ($word6den / $spacecount) * $density;
}

} ## End sub


##################################################
######################## Search results paging
##################################################

sub resultsgenerator {

$content = get($searchresultspage); ## data holds user input

($pagetop, $pagebottom) = split(/searchresultshere/, $content);

} ## End sub


##################################################
######################## Remove listing
##################################################

sub removelisting {

read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
@pairs = split(/&/, $buffer);
foreach $pair (@pairs) {
($name, $value) = split(/=/, $pair);
$value =~ tr/+/ /;
$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
$FORM{$name} = $value;
}

   open(INF,"adminpass.txt"); ## Open read file
   $userpass = <INF>; ## Put into an array
   close(INF); ## Close file
   chomp($userpass);
   ($username, $password) = split(/:/, $userpass);
   $enterpasscrypt = crypt($FORM{'password'}, substr($password, 0, 2));
	## If they match
   if ($FORM{'username'} ne $username || $enterpasscrypt ne $password){
	print "Invalid username or password";
      exit;
   } ## End if

$linenum = 1;
open(INF,"searchindex.asrs"); ## Open read file
@userdata = <INF>; ## Put into an array
close(INF); ## Close file
foreach $line (@userdata) {
chomp($line);
($word1, $score1, $word2, $score2, $word3, $score3, $word4, $score4, $word5, $score5, $word6, $score6, $sitename, $description, $url) = split(//, $line);
if ($url ne $FORM{'url'}) {
$TEMPINFO{$linenum} = $line;
$linenum++;
} ## End if
} ## End loop

open(OUTF,">searchindex.asrs"); ##  Banner file for appending
foreach $key (keys(%TEMPINFO)) {
print OUTF
"$TEMPINFO{$key}\n"; ## Write user fields
}
close(OUTF); ## Close file

print "Site removed";

} ## End sub


##################################################
######################## Style1
##################################################

sub style1 {

print <<EndHTML;

<tr>
<td><font face="$rankfont"><font color="$rankcolour"><font size=$ranksize>$ranknumber</font></font></font></td>
<td><font face="$sitenfont"><font color="$sitencolour"><font size=$sitensize><a href="$url">$sitename</a></font></font></font>
<br><font face="$sitedfont"><font color="$sitedcolour"><font size=$sitedsize>$description</font></font></font>
<br><font face="$siteufont"><font color="$siteucolour"><font size=$siteusize><a href="$url">$url</a></font></font></font></td>
</tr>

EndHTML
;

} ## End sub


##################################################
######################## Enter Admin
##################################################

sub admin {

print <<EndHTML;

<p align="center"><font size="6">Enter password to enter Admin
area</font></p>

<p align="center">&nbsp;</p>

<form action="$programurl/asrs.cgi?want=enteradmin" method="POST">
    <p align="center">Username <input type="text" size="20"
    name="username"></p>
    <p align="center">Password <input type="text" size="20"
    name="password"></p>
    <p align="center"><input type="submit" value="Enter"></p>
</form>

EndHTML
;

exit;
} ## End sub


##################################################
######################## Enter Admin
##################################################

sub enteradmin {

print <<EndHTML;

<p align="center"><font size="6">Fill in the below form to remove a site.</font></p>

<p align="center">&nbsp;</p>

<form action="$programurl/asrs.cgi?want=remove" method="POST">
    <p align="center">URL <input type="text" size="20"
    name="url"></p>
    <input type="hidden" name="password" value="$FORM{'password'}">
    <input type="hidden" name="username" value="$FORM{'username'}">
    <p align="center"><input type="submit" value="Remove"></p>
</form>

EndHTML
;

exit;
} ## End sub
